#property indicator_separate_window
#property indicator_minimum 0.00
#property indicator_maximum 100.00
#property indicator_color1 Lime
#property indicator_buffers 2
#property indicator_color2 Red
#property indicator_level1 20
#property indicator_level2 80

//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double Slw = 8;
extern double Pds = 13;
extern double Slwsignal = 9;
extern bool   showArrows = true;
extern string SignalName = "StochasticSignal";

double ExtHistoBuffer1[];
double ExtHistoBuffer2[];
double ExtHistoBuffer3[];

//------------------------------------------------------------------+
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0, ExtHistoBuffer1);
   SetIndexBuffer(1, ExtHistoBuffer2);
   SetIndexBuffer(2, ExtHistoBuffer3);
   return(0);
}

int deinit()
{
   DeleteArrows();
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1); 


   //
   //
   //
   //
   //
   
   double alpha1 = 2 / (1+Slw);
   double alpha2 = 2 / (1+Slwsignal);
   for(int i = limit; i>=0 ;i --)
   { 
      double high = High[iHighest(NULL, 0, MODE_HIGH,Pds,i)];
      double low  = Low[iLowest(NULL, 0, MODE_LOW,Pds,i)];
      double sto  = 0;
         if (high != low)
             sto = 100*(Close[i]-low)/(high-low);
             ExtHistoBuffer3[i] = ExtHistoBuffer3[i+1]+alpha1*(sto-ExtHistoBuffer3[i+1]);
             
      //
      //
      //
      //
      //
             sto = 0;             
	   double max = ExtHistoBuffer3[i];
	   double min = ExtHistoBuffer3[i];
	   for (int k = 1; k<Pds; k++)
	   {
	      min = MathMin(min,ExtHistoBuffer3[i+k]);
	      max = MathMax(max,ExtHistoBuffer3[i+k]);
	   }
	   if (max!=min)
         sto = 100*(ExtHistoBuffer3[i]-min)/(max-min);
	      ExtHistoBuffer1[i] = ExtHistoBuffer1[i+1]+alpha2*(sto-ExtHistoBuffer1[i+1]);
	      ExtHistoBuffer2[i] = ExtHistoBuffer2[i+1]+alpha1*(ExtHistoBuffer1[i]-ExtHistoBuffer2[i+1]);
   }	      
   
   //
   //
   //
   //
   
   DeleteArrows();
      if (showArrows)
      {
         double SignalGap = MathCeil(iATR(NULL,0,50,0)/Point);
         for (i=0; i<WindowBarsPerChart() ;i++)
         {
             if (ExtHistoBuffer2[i]>ExtHistoBuffer1[i] && ExtHistoBuffer2[i+1]<ExtHistoBuffer1[i+1]) DrawArrow(i,"up");
             if (ExtHistoBuffer2[i]<ExtHistoBuffer1[i] && ExtHistoBuffer2[i+1]>ExtHistoBuffer1[i+1]) DrawArrow(i,"down");
         }
      }            

      static bool BuyAlert  = false;
      static bool SellAlert = false;
      if(ExtHistoBuffer1[0] > ExtHistoBuffer2[0] && ExtHistoBuffer1[0]<20.1 && ExtHistoBuffer2[0] < 20.1 && BuyAlert==False)
      {
         Alert ("Doda-Stochastic says Buy  ",Symbol()," at ",Close[0]); 
         BuyAlert = True;
         SellAlert = False;
      }
   
      if(ExtHistoBuffer2[0] > ExtHistoBuffer1[0] && ExtHistoBuffer1[0]>80.1 && ExtHistoBuffer2[0] > 80.1 && SellAlert==False)
      {
         Alert ("Doda-Stochastic says Sell  ",Symbol()," at ",Close[0]); 
         BuyAlert = false;
         SellAlert = True;  
      }
      return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void DrawArrow(int i,string type)
{
      string name = StringConcatenate(SignalName,(string)Time[i]);
         
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      if (type=="up")
         {
            ObjectSet(name,OBJPROP_PRICE1,High[i]+iATR(NULL,0,50,i));
            ObjectSet(name,OBJPROP_ARROWCODE,242);
            ObjectSet(name,OBJPROP_COLOR,Red);
         }
      if (type=="down")
         {
            ObjectSet(name,OBJPROP_PRICE1,Low[i]-iATR(NULL,0,50,i));
            ObjectSet(name,OBJPROP_ARROWCODE,241);
            ObjectSet(name,OBJPROP_COLOR,LimeGreen);
         }
}
void DeleteArrows()
{
   int lookFor = StringLen(SignalName);
   for (int k=ObjectsTotal()-1; k>=0; k--)
   {
      string name = ObjectName(k); if (StringSubstr(name,0,lookFor)==SignalName) ObjectDelete(name);
   }      
}


